##// END OF EJS Templates
libnss-systemd was missing
Unknown -
r427:6dffc133c71d
parent child
Show More
@@ -1,811 +1,811
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 #Kernel Branch
48 #Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 #BIS= Kernel has KVM and zswap enabled
59 #BIS= Kernel has KVM and zswap enabled
60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
61 #default bcmrpi3_defconfig target kernel
61 #default bcmrpi3_defconfig target kernel
62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
63 #enhanced kernel
63 #enhanced kernel
64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
66
66
67 # Build directories
67 # Build directories
68 WORKDIR=$(pwd)
68 WORKDIR=$(pwd)
69 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
69 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
70 BUILDDIR="${BASEDIR}/build"
70 BUILDDIR="${BASEDIR}/build"
71
71
72 # Chroot directories
72 # Chroot directories
73 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
74 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
75 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
76 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
77 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
78 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
79
79
80 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82
82
83 # General settings
83 # General settings
84 SET_ARCH=${SET_ARCH:=32}
84 SET_ARCH=${SET_ARCH:=32}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
91
91
92 # Keyboard settings
92 # Keyboard settings
93 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97
97
98 # Network settings (DHCP)
98 # Network settings (DHCP)
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100
100
101 # Network settings (static)
101 # Network settings (static)
102 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
109
109
110 # APT settings
110 # APT settings
111 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113
113
114 # Feature settings
114 # Feature settings
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
127 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
130 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
133 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
134
134
135 # SSH settings
135 # SSH settings
136 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
137 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
138 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
139 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
140 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
141
141
142 # Advanced settings
142 # Advanced settings
143 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
144 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
145 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
146 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
147 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
147 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
148 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
148 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
149 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
149 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
150 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
150 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
151 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
151 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
152 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
152 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
153 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
153 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
154 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
154 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
155 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
155 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
156 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
156 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
157 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
157 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
158
158
159 # Kernel compilation settings
159 # Kernel compilation settings
160 BUILD_KERNEL=${BUILD_KERNEL:=true}
160 BUILD_KERNEL=${BUILD_KERNEL:=true}
161 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
161 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
162 KERNEL_THREADS=${KERNEL_THREADS:=1}
162 KERNEL_THREADS=${KERNEL_THREADS:=1}
163 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
163 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
164 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
164 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
165 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
165 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
166 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
166 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
167 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
167 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
168 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
168 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
169 KERNEL_VIRT=${KERNEL_VIRT:=false}
169 KERNEL_VIRT=${KERNEL_VIRT:=false}
170 KERNEL_BPF=${KERNEL_BPF:=false}
170 KERNEL_BPF=${KERNEL_BPF:=false}
171
171
172 # Kernel compilation from source directory settings
172 # Kernel compilation from source directory settings
173 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
173 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
174 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
174 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
175 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
175 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
176 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
176 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
177
177
178 # Reduce disk usage settings
178 # Reduce disk usage settings
179 REDUCE_APT=${REDUCE_APT:=true}
179 REDUCE_APT=${REDUCE_APT:=true}
180 REDUCE_DOC=${REDUCE_DOC:=true}
180 REDUCE_DOC=${REDUCE_DOC:=true}
181 REDUCE_MAN=${REDUCE_MAN:=true}
181 REDUCE_MAN=${REDUCE_MAN:=true}
182 REDUCE_VIM=${REDUCE_VIM:=false}
182 REDUCE_VIM=${REDUCE_VIM:=false}
183 REDUCE_BASH=${REDUCE_BASH:=false}
183 REDUCE_BASH=${REDUCE_BASH:=false}
184 REDUCE_HWDB=${REDUCE_HWDB:=true}
184 REDUCE_HWDB=${REDUCE_HWDB:=true}
185 REDUCE_SSHD=${REDUCE_SSHD:=true}
185 REDUCE_SSHD=${REDUCE_SSHD:=true}
186 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
186 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
187
187
188 # Encrypted filesystem settings
188 # Encrypted filesystem settings
189 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
189 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
190 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
190 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
191 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
191 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
192 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
192 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
193 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
193 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
194
194
195 # Chroot scripts directory
195 # Chroot scripts directory
196 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
196 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
197
197
198 # Packages required in the chroot build environment
198 # Packages required in the chroot build environment
199 APT_INCLUDES=${APT_INCLUDES:=""}
199 APT_INCLUDES=${APT_INCLUDES:=""}
200 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
200 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
201
201
202 #Packages to exclude from chroot build environment
202 #Packages to exclude from chroot build environment
203 APT_EXCLUDES=${APT_EXCLUDES:=""}
203 APT_EXCLUDES=${APT_EXCLUDES:=""}
204
204
205 # Packages required for bootstrapping
205 # Packages required for bootstrapping
206 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
206 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
207 MISSING_PACKAGES=""
207 MISSING_PACKAGES=""
208
208
209 # Packages installed for c/c++ build environment in chroot (keep empty)
209 # Packages installed for c/c++ build environment in chroot (keep empty)
210 COMPILER_PACKAGES=""
210 COMPILER_PACKAGES=""
211
211
212 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
212 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
213 if [ -n "$(lsof -i :3142)" ] ; then
213 if [ -n "$(lsof -i :3142)" ] ; then
214 HTTP_PROXY=http://127.0.0.1:3142/
214 HTTP_PROXY=http://127.0.0.1:3142/
215 fi
215 fi
216
216
217 #netselect-apt does not know buster yet
217 #netselect-apt does not know buster yet
218 if [ "$RELEASE" = "buster" ] ; then
218 if [ "$RELEASE" = "buster" ] ; then
219 RLS=testing
219 RLS=testing
220 else
220 else
221 RLS="$RELEASE"
221 RLS="$RELEASE"
222 fi
222 fi
223
223
224 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
224 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
225 rm "$(pwd)/files/apt/sources.list"
225 rm "$(pwd)/files/apt/sources.list"
226 fi
226 fi
227
227
228 if [ "$ENABLE_NONFREE" = true ] ; then
228 if [ "$ENABLE_NONFREE" = true ] ; then
229 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
229 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
230 else
230 else
231 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
231 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
232 fi
232 fi
233
233
234 #sed and cut the result string so we can use it as APT_SERVER
234 #sed and cut the result string so we can use it as APT_SERVER
235 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
235 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
236
236
237 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
237 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
238 if [ -n "$SET_ARCH" ] ; then
238 if [ -n "$SET_ARCH" ] ; then
239 # 64 bit configuration
239 # 64 bit configuration
240 if [ "$SET_ARCH" = 64 ] ; then
240 if [ "$SET_ARCH" = 64 ] ; then
241 # General 64 bit depended settings
241 # General 64 bit depended settings
242 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
242 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
243 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
243 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
244 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
244 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
245
245
246 # Board specific settings
246 # Board specific settings
247 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
247 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
248 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
248 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
249 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
249 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
250 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
250 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
251 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
251 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
252 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
252 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
253 else
253 else
254 echo "error: Only Raspberry PI 3 and 3B+ support 64 bit"
254 echo "error: Only Raspberry PI 3 and 3B+ support 64 bit"
255 exit 1
255 exit 1
256 fi
256 fi
257 fi
257 fi
258
258
259 # 32 bit configuration
259 # 32 bit configuration
260 if [ "$SET_ARCH" = 32 ] ; then
260 if [ "$SET_ARCH" = 32 ] ; then
261 # General 32 bit dependend settings
261 # General 32 bit dependend settings
262 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
262 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
263 KERNEL_ARCH=${KERNEL_ARCH:=arm}
263 KERNEL_ARCH=${KERNEL_ARCH:=arm}
264 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
264 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
265
265
266 # Hardware specific settings
266 # Hardware specific settings
267 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
267 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
268 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
268 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
269 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
269 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
270 RELEASE_ARCH=${RELEASE_ARCH:=armel}
270 RELEASE_ARCH=${RELEASE_ARCH:=armel}
271 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
271 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
272 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
272 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
273 fi
273 fi
274
274
275 # Hardware specific settings
275 # Hardware specific settings
276 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
276 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
277 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
277 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
278 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
278 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
279 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
279 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
280 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
280 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
281 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
281 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
282 fi
282 fi
283 fi
283 fi
284 #SET_ARCH not set
284 #SET_ARCH not set
285 else
285 else
286 echo "error: Please set '32' or '64' as value for SET_ARCH"
286 echo "error: Please set '32' or '64' as value for SET_ARCH"
287 exit 1
287 exit 1
288 fi
288 fi
289 # Device specific configuration and U-Boot configuration
289 # Device specific configuration and U-Boot configuration
290 case "$RPI_MODEL" in
290 case "$RPI_MODEL" in
291 0)
291 0)
292 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
292 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
293 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
293 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
294 ;;
294 ;;
295 1)
295 1)
296 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
296 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
297 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
297 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
298 ;;
298 ;;
299 1P)
299 1P)
300 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
300 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
301 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
301 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
302 ;;
302 ;;
303 2)
303 2)
304 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
304 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
305 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
305 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
306 ;;
306 ;;
307 3)
307 3)
308 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
308 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
309 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
309 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
310 ;;
310 ;;
311 3P)
311 3P)
312 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
312 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
313 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
313 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
314 ;;
314 ;;
315 *)
315 *)
316 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
316 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
317 exit 1
317 exit 1
318 ;;
318 ;;
319 esac
319 esac
320
320
321 # Prepare date string for default image file name
321 # Prepare date string for default image file name
322 DATE="$(date +%Y-%m-%d)"
322 DATE="$(date +%Y-%m-%d)"
323 if [ -z "$KERNEL_BRANCH" ] ; then
323 if [ -z "$KERNEL_BRANCH" ] ; then
324 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
324 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
325 else
325 else
326 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
326 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
327 fi
327 fi
328
328
329 # Check if the internal wireless interface is supported by the RPi model
329 # Check if the internal wireless interface is supported by the RPi model
330 if [ "$ENABLE_WIRELESS" = true ] ; then
330 if [ "$ENABLE_WIRELESS" = true ] ; then
331 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
331 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
332 echo "error: The selected Raspberry Pi model has no internal wireless interface"
332 echo "error: The selected Raspberry Pi model has no internal wireless interface"
333 exit 1
333 exit 1
334 fi
334 fi
335 fi
335 fi
336
336
337 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
337 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
338 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
338 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
339 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
339 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
340 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
340 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
341 exit 1
341 exit 1
342 fi
342 fi
343 fi
343 fi
344
344
345 # Add cmake to compile videocore sources
345 # Add cmake to compile videocore sources
346 if [ "$ENABLE_VIDEOCORE" = true ] ; then
346 if [ "$ENABLE_VIDEOCORE" = true ] ; then
347 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
347 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
348 fi
348 fi
349
349
350 # Add libncurses5 to enable kernel menuconfig
350 # Add libncurses5 to enable kernel menuconfig
351 if [ "$KERNEL_MENUCONFIG" = true ] ; then
351 if [ "$KERNEL_MENUCONFIG" = true ] ; then
352 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
352 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
353 fi
353 fi
354
354
355 # Add ccache compiler cache for (faster) kernel cross (re)compilation
355 # Add ccache compiler cache for (faster) kernel cross (re)compilation
356 if [ "$KERNEL_CCACHE" = true ] ; then
356 if [ "$KERNEL_CCACHE" = true ] ; then
357 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
357 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
358 fi
358 fi
359
359
360 # Add cryptsetup package to enable filesystem encryption
360 # Add cryptsetup package to enable filesystem encryption
361 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
361 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
362 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
362 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
363 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
363 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
364
364
365 if [ -z "$CRYPTFS_PASSWORD" ] ; then
365 if [ -z "$CRYPTFS_PASSWORD" ] ; then
366 echo "error: no password defined (CRYPTFS_PASSWORD)!"
366 echo "error: no password defined (CRYPTFS_PASSWORD)!"
367 exit 1
367 exit 1
368 fi
368 fi
369 ENABLE_INITRAMFS=true
369 ENABLE_INITRAMFS=true
370 fi
370 fi
371
371
372 # Add initramfs generation tools
372 # Add initramfs generation tools
373 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
373 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
374 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
374 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
375 fi
375 fi
376
376
377 # Add device-tree-compiler required for building the U-Boot bootloader
377 # Add device-tree-compiler required for building the U-Boot bootloader
378 if [ "$ENABLE_UBOOT" = true ] ; then
378 if [ "$ENABLE_UBOOT" = true ] ; then
379 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
379 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
380 else
380 else
381 if [ "$ENABLE_UBOOTUSB" = true ] ; then
381 if [ "$ENABLE_UBOOTUSB" = true ] ; then
382 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
382 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
383 exit 1
383 exit 1
384 fi
384 fi
385 fi
385 fi
386
386
387 # Check if root SSH (v2) public key file exists
387 # Check if root SSH (v2) public key file exists
388 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
388 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
389 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
389 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
390 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
390 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
391 exit 1
391 exit 1
392 fi
392 fi
393 fi
393 fi
394
394
395 # Check if $USER_NAME SSH (v2) public key file exists
395 # Check if $USER_NAME SSH (v2) public key file exists
396 if [ -n "$SSH_USER_PUB_KEY" ] ; then
396 if [ -n "$SSH_USER_PUB_KEY" ] ; then
397 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
397 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
398 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
398 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
399 exit 1
399 exit 1
400 fi
400 fi
401 fi
401 fi
402
402
403 # Check if all required packages are installed on the build system
403 # Check if all required packages are installed on the build system
404 for package in $REQUIRED_PACKAGES ; do
404 for package in $REQUIRED_PACKAGES ; do
405 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
405 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
406 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
406 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
407 fi
407 fi
408 done
408 done
409
409
410 # If there are missing packages ask confirmation for install, or exit
410 # If there are missing packages ask confirmation for install, or exit
411 if [ -n "$MISSING_PACKAGES" ] ; then
411 if [ -n "$MISSING_PACKAGES" ] ; then
412 echo "the following packages needed by this script are not installed:"
412 echo "the following packages needed by this script are not installed:"
413 echo "$MISSING_PACKAGES"
413 echo "$MISSING_PACKAGES"
414
414
415 printf "\ndo you want to install the missing packages right now? [y/n] "
415 printf "\ndo you want to install the missing packages right now? [y/n] "
416 read -r confirm
416 read -r confirm
417 [ "$confirm" != "y" ] && exit 1
417 [ "$confirm" != "y" ] && exit 1
418
418
419 # Make sure all missing required packages are installed
419 # Make sure all missing required packages are installed
420 apt-get -qq -y install "${MISSING_PACKAGES}"
420 apt-get -qq -y install "${MISSING_PACKAGES}"
421 fi
421 fi
422
422
423 # Check if ./bootstrap.d directory exists
423 # Check if ./bootstrap.d directory exists
424 if [ ! -d "./bootstrap.d/" ] ; then
424 if [ ! -d "./bootstrap.d/" ] ; then
425 echo "error: './bootstrap.d' required directory not found!"
425 echo "error: './bootstrap.d' required directory not found!"
426 exit 1
426 exit 1
427 fi
427 fi
428
428
429 # Check if ./files directory exists
429 # Check if ./files directory exists
430 if [ ! -d "./files/" ] ; then
430 if [ ! -d "./files/" ] ; then
431 echo "error: './files' required directory not found!"
431 echo "error: './files' required directory not found!"
432 exit 1
432 exit 1
433 fi
433 fi
434
434
435 # Check if specified KERNELSRC_DIR directory exists
435 # Check if specified KERNELSRC_DIR directory exists
436 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
436 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
437 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
437 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
438 exit 1
438 exit 1
439 fi
439 fi
440
440
441 # Check if specified UBOOTSRC_DIR directory exists
441 # Check if specified UBOOTSRC_DIR directory exists
442 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
442 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
443 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
443 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
444 exit 1
444 exit 1
445 fi
445 fi
446
446
447 # Check if specified VIDEOCORESRC_DIR directory exists
447 # Check if specified VIDEOCORESRC_DIR directory exists
448 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
448 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
449 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
449 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
450 exit 1
450 exit 1
451 fi
451 fi
452
452
453 # Check if specified FBTURBOSRC_DIR directory exists
453 # Check if specified FBTURBOSRC_DIR directory exists
454 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
454 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
455 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
455 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
456 exit 1
456 exit 1
457 fi
457 fi
458
458
459 # Check if specified CHROOT_SCRIPTS directory exists
459 # Check if specified CHROOT_SCRIPTS directory exists
460 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
460 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
461 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
461 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
462 exit 1
462 exit 1
463 fi
463 fi
464
464
465 # Check if specified device mapping already exists (will be used by cryptsetup)
465 # Check if specified device mapping already exists (will be used by cryptsetup)
466 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
466 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
467 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
467 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
468 exit 1
468 exit 1
469 fi
469 fi
470
470
471 # Don't clobber an old build
471 # Don't clobber an old build
472 if [ -e "$BUILDDIR" ] ; then
472 if [ -e "$BUILDDIR" ] ; then
473 echo "error: directory ${BUILDDIR} already exists, not proceeding"
473 echo "error: directory ${BUILDDIR} already exists, not proceeding"
474 exit 1
474 exit 1
475 fi
475 fi
476
476
477 # Setup chroot directory
477 # Setup chroot directory
478 mkdir -p "${R}"
478 mkdir -p "${R}"
479
479
480 # Check if build directory has enough of free disk space >512MB
480 # Check if build directory has enough of free disk space >512MB
481 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
481 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
482 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
482 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
483 exit 1
483 exit 1
484 fi
484 fi
485
485
486 set -x
486 set -x
487
487
488 # Call "cleanup" function on various signals and errors
488 # Call "cleanup" function on various signals and errors
489 trap cleanup 0 1 2 3 6
489 trap cleanup 0 1 2 3 6
490
490
491 # Add required packages for the minbase installation
491 # Add required packages for the minbase installation
492 if [ "$ENABLE_MINBASE" = true ] ; then
492 if [ "$ENABLE_MINBASE" = true ] ; then
493 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
493 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
494 fi
494 fi
495
495
496 # Add parted package, required to get partprobe utility
496 # Add parted package, required to get partprobe utility
497 if [ "$EXPANDROOT" = true ] ; then
497 if [ "$EXPANDROOT" = true ] ; then
498 APT_INCLUDES="${APT_INCLUDES},parted"
498 APT_INCLUDES="${APT_INCLUDES},parted"
499 fi
499 fi
500
500
501 # Add dbus package, recommended if using systemd
501 # Add dbus package, recommended if using systemd
502 if [ "$ENABLE_DBUS" = true ] ; then
502 if [ "$ENABLE_DBUS" = true ] ; then
503 APT_INCLUDES="${APT_INCLUDES},dbus"
503 APT_INCLUDES="${APT_INCLUDES},dbus"
504 fi
504 fi
505
505
506 # Add iptables IPv4/IPv6 package
506 # Add iptables IPv4/IPv6 package
507 if [ "$ENABLE_IPTABLES" = true ] ; then
507 if [ "$ENABLE_IPTABLES" = true ] ; then
508 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
508 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
509 fi
509 fi
510
510
511 # Add openssh server package
511 # Add openssh server package
512 if [ "$ENABLE_SSHD" = true ] ; then
512 if [ "$ENABLE_SSHD" = true ] ; then
513 APT_INCLUDES="${APT_INCLUDES},openssh-server"
513 APT_INCLUDES="${APT_INCLUDES},openssh-server"
514 fi
514 fi
515
515
516 # Add alsa-utils package
516 # Add alsa-utils package
517 if [ "$ENABLE_SOUND" = true ] ; then
517 if [ "$ENABLE_SOUND" = true ] ; then
518 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
518 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
519 fi
519 fi
520
520
521 # Add rng-tools package
521 # Add rng-tools package
522 if [ "$ENABLE_HWRANDOM" = true ] ; then
522 if [ "$ENABLE_HWRANDOM" = true ] ; then
523 APT_INCLUDES="${APT_INCLUDES},rng-tools"
523 APT_INCLUDES="${APT_INCLUDES},rng-tools"
524 fi
524 fi
525
525
526 # Add fbturbo video driver
526 # Add fbturbo video driver
527 if [ "$ENABLE_FBTURBO" = true ] ; then
527 if [ "$ENABLE_FBTURBO" = true ] ; then
528 # Enable xorg package dependencies
528 # Enable xorg package dependencies
529 ENABLE_XORG=true
529 ENABLE_XORG=true
530 fi
530 fi
531
531
532 # Add user defined window manager package
532 # Add user defined window manager package
533 if [ -n "$ENABLE_WM" ] ; then
533 if [ -n "$ENABLE_WM" ] ; then
534 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
534 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
535
535
536 # Enable xorg package dependencies
536 # Enable xorg package dependencies
537 ENABLE_XORG=true
537 ENABLE_XORG=true
538 fi
538 fi
539
539
540 # Add xorg package
540 # Add xorg package
541 if [ "$ENABLE_XORG" = true ] ; then
541 if [ "$ENABLE_XORG" = true ] ; then
542 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
542 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
543 fi
543 fi
544
544
545 # Replace selected packages with smaller clones
545 # Replace selected packages with smaller clones
546 if [ "$ENABLE_REDUCE" = true ] ; then
546 if [ "$ENABLE_REDUCE" = true ] ; then
547 # Add levee package instead of vim-tiny
547 # Add levee package instead of vim-tiny
548 if [ "$REDUCE_VIM" = true ] ; then
548 if [ "$REDUCE_VIM" = true ] ; then
549 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
549 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
550 fi
550 fi
551
551
552 # Add dropbear package instead of openssh-server
552 # Add dropbear package instead of openssh-server
553 if [ "$REDUCE_SSHD" = true ] ; then
553 if [ "$REDUCE_SSHD" = true ] ; then
554 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
554 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
555 fi
555 fi
556 fi
556 fi
557
557
558 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
558 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
559 if [ "$ENABLE_SYSVINIT" = false ] ; then
559 if [ "$ENABLE_SYSVINIT" = false ] ; then
560 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
560 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
561 fi
561 fi
562
562
563 # Configure kernel sources if no KERNELSRC_DIR
563 # Configure kernel sources if no KERNELSRC_DIR
564 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
564 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
565 KERNELSRC_CONFIG=true
565 KERNELSRC_CONFIG=true
566 fi
566 fi
567
567
568 # Configure reduced kernel
568 # Configure reduced kernel
569 if [ "$KERNEL_REDUCE" = true ] ; then
569 if [ "$KERNEL_REDUCE" = true ] ; then
570 KERNELSRC_CONFIG=false
570 KERNELSRC_CONFIG=false
571 fi
571 fi
572
572
573 # Configure qemu compatible kernel
573 # Configure qemu compatible kernel
574 if [ "$ENABLE_QEMU" = true ] ; then
574 if [ "$ENABLE_QEMU" = true ] ; then
575 DTB_FILE=vexpress-v2p-ca15_a7.dtb
575 DTB_FILE=vexpress-v2p-ca15_a7.dtb
576 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
576 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
577 KERNEL_DEFCONFIG="vexpress_defconfig"
577 KERNEL_DEFCONFIG="vexpress_defconfig"
578 if [ "$KERNEL_MENUCONFIG" = false ] ; then
578 if [ "$KERNEL_MENUCONFIG" = false ] ; then
579 KERNEL_OLDDEFCONFIG=true
579 KERNEL_OLDDEFCONFIG=true
580 fi
580 fi
581 fi
581 fi
582
582
583 # Execute bootstrap scripts
583 # Execute bootstrap scripts
584 for SCRIPT in bootstrap.d/*.sh; do
584 for SCRIPT in bootstrap.d/*.sh; do
585 head -n 3 "$SCRIPT"
585 head -n 3 "$SCRIPT"
586 . "$SCRIPT"
586 . "$SCRIPT"
587 done
587 done
588
588
589 ## Execute custom bootstrap scripts
589 ## Execute custom bootstrap scripts
590 if [ -d "custom.d" ] ; then
590 if [ -d "custom.d" ] ; then
591 for SCRIPT in custom.d/*.sh; do
591 for SCRIPT in custom.d/*.sh; do
592 . "$SCRIPT"
592 . "$SCRIPT"
593 done
593 done
594 fi
594 fi
595
595
596 # Execute custom scripts inside the chroot
596 # Execute custom scripts inside the chroot
597 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
597 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
598 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
598 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
599 chroot_exec /bin/bash -x <<'EOF'
599 chroot_exec /bin/bash -x <<'EOF'
600 for SCRIPT in /chroot_scripts/* ; do
600 for SCRIPT in /chroot_scripts/* ; do
601 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
601 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
602 $SCRIPT
602 $SCRIPT
603 fi
603 fi
604 done
604 done
605 EOF
605 EOF
606 rm -rf "${R}/chroot_scripts"
606 rm -rf "${R}/chroot_scripts"
607 fi
607 fi
608
608
609 # Remove c/c++ build environment from the chroot
609 # Remove c/c++ build environment from the chroot
610 chroot_remove_cc
610 chroot_remove_cc
611
611
612 # Generate required machine-id
612 # Generate required machine-id
613 MACHINE_ID=$(dbus-uuidgen)
613 MACHINE_ID=$(dbus-uuidgen)
614 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
614 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
615 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
615 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
616
616
617 # APT Cleanup
617 # APT Cleanup
618 chroot_exec apt-get -y clean
618 chroot_exec apt-get -y clean
619 chroot_exec apt-get -y autoclean
619 chroot_exec apt-get -y autoclean
620 chroot_exec apt-get -y autoremove
620 chroot_exec apt-get -y autoremove
621
621
622 # Unmount mounted filesystems
622 # Unmount mounted filesystems
623 umount -l "${R}/proc"
623 umount -l "${R}/proc"
624 umount -l "${R}/sys"
624 umount -l "${R}/sys"
625
625
626 # Clean up directories
626 # Clean up directories
627 rm -rf "${R}/run/*"
627 rm -rf "${R}/run/*"
628 rm -rf "${R}/tmp/*"
628 rm -rf "${R}/tmp/*"
629
629
630 # Clean up files
630 # Clean up files
631 rm -f "${ETC_DIR}/ssh/ssh_host_*"
631 rm -f "${ETC_DIR}/ssh/ssh_host_*"
632 rm -f "${ETC_DIR}/dropbear/dropbear_*"
632 rm -f "${ETC_DIR}/dropbear/dropbear_*"
633 rm -f "${ETC_DIR}/apt/sources.list.save"
633 rm -f "${ETC_DIR}/apt/sources.list.save"
634 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
634 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
635 rm -f "${ETC_DIR}/*-"
635 rm -f "${ETC_DIR}/*-"
636 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
636 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
637 rm -f "${ETC_DIR}/resolv.conf"
637 rm -f "${ETC_DIR}/resolv.conf"
638 rm -f "${R}/root/.bash_history"
638 rm -f "${R}/root/.bash_history"
639 rm -f "${R}/var/lib/urandom/random-seed"
639 rm -f "${R}/var/lib/urandom/random-seed"
640 rm -f "${R}/initrd.img"
640 rm -f "${R}/initrd.img"
641 rm -f "${R}/vmlinuz"
641 rm -f "${R}/vmlinuz"
642 rm -f "${R}${QEMU_BINARY}"
642 rm -f "${R}${QEMU_BINARY}"
643
643
644 if [ "$ENABLE_QEMU" = true ] ; then
644 if [ "$ENABLE_QEMU" = true ] ; then
645 # Setup QEMU directory
645 # Setup QEMU directory
646 mkdir "${BASEDIR}/qemu"
646 mkdir "${BASEDIR}/qemu"
647
647
648 # Copy kernel image to QEMU directory
648 # Copy kernel image to QEMU directory
649 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
649 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
650
650
651 # Copy kernel config to QEMU directory
651 # Copy kernel config to QEMU directory
652 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
652 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
653
653
654 # Copy kernel dtbs to QEMU directory
654 # Copy kernel dtbs to QEMU directory
655 for dtb in "${BOOT_DIR}/"*.dtb ; do
655 for dtb in "${BOOT_DIR}/"*.dtb ; do
656 if [ -f "${dtb}" ] ; then
656 if [ -f "${dtb}" ] ; then
657 install_readonly "${dtb}" "${BASEDIR}/qemu/"
657 install_readonly "${dtb}" "${BASEDIR}/qemu/"
658 fi
658 fi
659 done
659 done
660
660
661 # Copy kernel overlays to QEMU directory
661 # Copy kernel overlays to QEMU directory
662 if [ -d "${BOOT_DIR}/overlays" ] ; then
662 if [ -d "${BOOT_DIR}/overlays" ] ; then
663 # Setup overlays dtbs directory
663 # Setup overlays dtbs directory
664 mkdir "${BASEDIR}/qemu/overlays"
664 mkdir "${BASEDIR}/qemu/overlays"
665
665
666 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
666 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
667 if [ -f "${dtb}" ] ; then
667 if [ -f "${dtb}" ] ; then
668 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
668 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
669 fi
669 fi
670 done
670 done
671 fi
671 fi
672
672
673 # Copy u-boot files to QEMU directory
673 # Copy u-boot files to QEMU directory
674 if [ "$ENABLE_UBOOT" = true ] ; then
674 if [ "$ENABLE_UBOOT" = true ] ; then
675 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
675 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
676 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
676 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
677 fi
677 fi
678 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
678 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
679 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
679 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
680 fi
680 fi
681 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
681 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
682 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
682 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
683 fi
683 fi
684 fi
684 fi
685
685
686 # Copy initramfs to QEMU directory
686 # Copy initramfs to QEMU directory
687 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
687 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
688 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
688 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
689 fi
689 fi
690 fi
690 fi
691
691
692 # Calculate size of the chroot directory in KB
692 # Calculate size of the chroot directory in KB
693 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
693 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
694
694
695 # Calculate the amount of needed 512 Byte sectors
695 # Calculate the amount of needed 512 Byte sectors
696 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
696 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
697 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
697 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
698 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
698 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
699
699
700 # The root partition is EXT4
700 # The root partition is EXT4
701 # This means more space than the actual used space of the chroot is used.
701 # This means more space than the actual used space of the chroot is used.
702 # As overhead for journaling and reserved blocks 35% are added.
702 # As overhead for journaling and reserved blocks 35% are added.
703 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
703 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
704
704
705 # Calculate required image size in 512 Byte sectors
705 # Calculate required image size in 512 Byte sectors
706 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
706 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
707
707
708 # Prepare image file
708 # Prepare image file
709 if [ "$ENABLE_SPLITFS" = true ] ; then
709 if [ "$ENABLE_SPLITFS" = true ] ; then
710 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
710 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
711 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
711 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
712 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
712 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
713 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
713 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
714
714
715 # Write firmware/boot partition tables
715 # Write firmware/boot partition tables
716 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
716 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
717 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
717 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
718 EOM
718 EOM
719
719
720 # Write root partition table
720 # Write root partition table
721 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
721 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
722 ${TABLE_SECTORS},${ROOT_SECTORS},83
722 ${TABLE_SECTORS},${ROOT_SECTORS},83
723 EOM
723 EOM
724
724
725 # Setup temporary loop devices
725 # Setup temporary loop devices
726 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
726 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
727 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
727 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
728 else # ENABLE_SPLITFS=false
728 else # ENABLE_SPLITFS=false
729 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
729 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
730 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
730 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
731
731
732 # Write partition table
732 # Write partition table
733 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
733 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
734 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
734 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
735 ${ROOT_OFFSET},${ROOT_SECTORS},83
735 ${ROOT_OFFSET},${ROOT_SECTORS},83
736 EOM
736 EOM
737
737
738 # Setup temporary loop devices
738 # Setup temporary loop devices
739 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
739 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
740 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
740 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
741 fi
741 fi
742
742
743 if [ "$ENABLE_CRYPTFS" = true ] ; then
743 if [ "$ENABLE_CRYPTFS" = true ] ; then
744 # Create dummy ext4 fs
744 # Create dummy ext4 fs
745 mkfs.ext4 "$ROOT_LOOP"
745 mkfs.ext4 "$ROOT_LOOP"
746
746
747 # Setup password keyfile
747 # Setup password keyfile
748 touch .password
748 touch .password
749 chmod 600 .password
749 chmod 600 .password
750 echo -n ${CRYPTFS_PASSWORD} > .password
750 echo -n ${CRYPTFS_PASSWORD} > .password
751
751
752 # Initialize encrypted partition
752 # Initialize encrypted partition
753 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
753 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
754
754
755 # Open encrypted partition and setup mapping
755 # Open encrypted partition and setup mapping
756 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
756 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
757
757
758 # Secure delete password keyfile
758 # Secure delete password keyfile
759 shred -zu .password
759 shred -zu .password
760
760
761 # Update temporary loop device
761 # Update temporary loop device
762 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
762 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
763
763
764 # Wipe encrypted partition (encryption cipher is used for randomness)
764 # Wipe encrypted partition (encryption cipher is used for randomness)
765 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
765 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
766 fi
766 fi
767
767
768 # Build filesystems
768 # Build filesystems
769 mkfs.vfat "$FRMW_LOOP"
769 mkfs.vfat "$FRMW_LOOP"
770 mkfs.ext4 "$ROOT_LOOP"
770 mkfs.ext4 "$ROOT_LOOP"
771
771
772 # Mount the temporary loop devices
772 # Mount the temporary loop devices
773 mkdir -p "$BUILDDIR/mount"
773 mkdir -p "$BUILDDIR/mount"
774 mount "$ROOT_LOOP" "$BUILDDIR/mount"
774 mount "$ROOT_LOOP" "$BUILDDIR/mount"
775
775
776 mkdir -p "$BUILDDIR/mount/boot/firmware"
776 mkdir -p "$BUILDDIR/mount/boot/firmware"
777 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
777 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
778
778
779 # Copy all files from the chroot to the loop device mount point directory
779 # Copy all files from the chroot to the loop device mount point directory
780 rsync -a "${R}/" "$BUILDDIR/mount/"
780 rsync -a "${R}/" "$BUILDDIR/mount/"
781
781
782 # Unmount all temporary loop devices and mount points
782 # Unmount all temporary loop devices and mount points
783 cleanup
783 cleanup
784
784
785 # Create block map file(s) of image(s)
785 # Create block map file(s) of image(s)
786 if [ "$ENABLE_SPLITFS" = true ] ; then
786 if [ "$ENABLE_SPLITFS" = true ] ; then
787 # Create block map files for "bmaptool"
787 # Create block map files for "bmaptool"
788 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
788 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
789 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
789 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
790
790
791 # Image was successfully created
791 # Image was successfully created
792 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
792 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
793 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
793 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
794 else
794 else
795 # Create block map file for "bmaptool"
795 # Create block map file for "bmaptool"
796 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
796 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
797
797
798 # Image was successfully created
798 # Image was successfully created
799 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
799 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
800
800
801 # Create qemu qcow2 image
801 # Create qemu qcow2 image
802 if [ "$ENABLE_QEMU" = true ] ; then
802 if [ "$ENABLE_QEMU" = true ] ; then
803 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
803 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
804 QEMU_SIZE=16G
804 QEMU_SIZE=16G
805
805
806 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
806 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
807 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
807 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
808
808
809 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
809 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
810 fi
810 fi
811 fi
811 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant